ur_rna.Utilities

## Class ConverterFilter.FilterIterator

- java.lang.Object
- - ur_rna.Utilities.ConverterFilter.FilterIterator

- All Implemented Interfaces:
    java.util.Iterator<C>
  Enclosing class:
    ConverterFilter<T,C>

      private class ConverterFilter.FilterIterator
      extends java.lang.Object
      implements java.util.Iterator<C>

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static int` | `AT_END`
    `private static int` | `AWAITING_CONSUMER`
    `private T` | `foundItem`
    `private static int` | `ITERATING`
    `private java.util.Iterator<T>` | `iterator`
    `private int` | `state`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `private` | `FilterIterator(java.util.Iterator<T> iterator)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `hasNext()`
    `private boolean` | `moveToNext()` Advances the underlying iterator and searches for the next passing item.
    `C` | `next()`
    `void` | `remove()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Field Detail

    - #### AT_END

          private static final int AT_END

      See Also:
        Constant Field Values

    - #### AWAITING_CONSUMER

          private static final int AWAITING_CONSUMER

      See Also:
        Constant Field Values

    - #### foundItem

          private T foundItem

    - #### ITERATING

          private static final int ITERATING

      See Also:
        Constant Field Values

    - #### iterator

          private java.util.Iterator<T> iterator

    - #### state

          private int state

  - ### Constructor Detail

    - #### FilterIterator

          private FilterIterator(java.util.Iterator<T> iterator)

  - ### Method Detail

    - #### hasNext

          public boolean hasNext()

      Specified by:
        `hasNext` in interface `java.util.Iterator<C>`

    - #### moveToNext

          private boolean moveToNext()

      Advances the underlying iterator and searches for the next passing item.

      The underlying iterator is only advanced if the previously found item has been consumed (by a call to next() function). This means that calls to hasNext() will only cause the iterator to advance on the first call, and all subsequent calls will NOT advance the iterator until next() has been called.

      Returns:
        True if a passing item was found or false otherwise. The latter result also indicates that the underlying iterator reached its end, and subsequent calls to hasNext() should return false.

    - #### next

          public C next()

      Specified by:
        `next` in interface `java.util.Iterator<C>`

    - #### remove

          public void remove()

      Specified by:
        `remove` in interface `java.util.Iterator<C>`